#ifndef __ENZOGRIDHIERARCHY_HH_
#define __ENZOGRIDHIERARCHY_HH_
#include <FlexArrayTmpl.H>
#include "EnzoGridInfo.hh"

struct EnzoGridHierarchy {
  typedef FlexArray<float> FlexArrayFloat;
  FlexArray<EnzoGridInfo*> grids;
  typedef FlexArray<EnzoGridInfo*> GridLevel;
  FlexArray<GridLevel> levels;
  FlexArray<FlexArrayFloat> StarData;
  FlexArray<char *> StarDataNames;
  // Methods------------------------------------
  EnzoGridHierarchy(char *file){
    readHierarchy(file);
  } 
  EnzoGridHierarchy(){} // default constructor
  ~EnzoGridHierarchy();
  int readHierarchy(char *file);
  int outputInfo(FILE *file=stdout);
  // for now lets just have it ouptut a single step of the hierarchy
  // but output all of the fields as well as particle positions.
  // maybe convert particle positions into a time-series expression
  // express coords as 3:nparts for interlaced and nparts:3 for non-interlaced
  int writeAllJad(char *filenameprefix,int step = 0);
  int writeJad(char *filename,char *fieldname="Density",int step=0);
  int writeGasParticles(char *filename,char *fieldname="Density",int step=0);
  int writeAllGasParticles(char *filename,int step=0);
  int writeDMParticles(char *filename,char *fieldname,int step=0);
  int writeAllDMParticles(char *filename,int step=0);
  int writeAllDMParticlesMPI(char *filename,int step=0);
  int writeStarParticles(char *filename,char *fieldname,int step=0);
  int writeAllStarParticles(char *filename,int step=0);
  int writeAllStarParticlesMPI(char *filename,int step=0);
  static int readStarData(char *starfile,
			  FlexArray<char *> &names,
			  FlexArray<FlexArrayFloat> &data);
  static int mapIndexedData(int length,
			    int *indices,
			    float *inputdata,
			    float *outputdata);
};

#endif
